# YII2框架介绍：

yii是一个基于组件的高性能php框架，用于开发大型Web应用。Yii采用严格的OOP编写，并有着完善的库引用以及全面的教程。

Yii有两个最主要的版本：Yii1.1和Yii2.0。Yii1.1是老的版本，现在已经不再进行新的开发了，官方只是进行维护，更新安全漏洞等，不会再有新的功能特性的引入。

而Yii2.0是在Yii1.1的基础上完全推倒重新写的一个框架，吸收了许多当前最新的技术和开发中的主流约定， 是最新一代Web开发框架的代表。

运用了PHP命名空间、Trait、 PSR标准 、Composer和Bower包管理器， 等新技术新标准。

实现了 依赖注入和依赖注入容器 以及 服务定位器（Service Locator） 等新架构新模式。

Yii2.0格外重视安全性，采取一系列手段有效防止SQL注入、XSS攻击、CSRF攻击、cookie篡改等。

为苦命码农提供了 Yii调试工具条 和 Gii代码生成器 以及 文档生成器 等高效开发工具。

集成了 Codeception 和 Faker，并与DB Migration相结合，提供了一个fixture框架，方便测试开发。

提供了一个简单应用模板和高级应用模板，适用于不同的开发场景，都可以帮助开发者尽快搭建起自己的应用。

## YII2框架的优缺点

### 优点：

1、纯OOP

2、用于大规模Web应用

3、模型使用方便

4、开发速度快，运行速度也快。性能优异且功能丰富

5、使用命令行工具。

6、支持composer包管理工具

7、gii蛮不错的，简化了开发流程，可以生成绝大数的代码，开发后台等效率还是蛮高的

### 缺点：

1、对Model层的指导和考虑较少

2、文档实例较少

3、英文太多

4、要求PHP技术精通，OOP编程要熟练！

5、View并不是理想view，理想中的view可能只是html代码，不会涉及PHP代码。

6、前后端完全的分离的趋势下，yii2前后端的耦合的还是有些重了